"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$ = void 0;
var tslib_1 = require("tslib");
var react_1 = require("react");
var rxjs_1 = require("rxjs");
function $(_a) {
    var children = _a.children;
    // store children
    var _b = tslib_1.__read(react_1.useState(null), 2), cn = _b[0], setCn = _b[1];
    react_1.useEffect(function () {
        // multiple children, one of em might be observable
        if (Array.isArray(children)) {
            setCn(children.map(function (c) { return react_1.default.createElement($, null, c); }));
            return;
        }
        // single observable child
        if (rxjs_1.isObservable(children)) {
            var sub_1 = children.subscribe(function (cn) {
                setCn(cn);
            });
            return function () { return sub_1.unsubscribe(); };
        }
        // child is just a child
        setCn(children);
    }, [children]);
    // render children as array
    return Array.isArray(cn)
        ? react_1.default.createElement.apply(react_1.default, tslib_1.__spread([react_1.default.Fragment, null], cn)) : react_1.default.createElement(react_1.default.Fragment, null, cn);
}
exports.$ = $;
