import { __read, __spread } from "tslib";
import React, { useEffect, useState } from "react";
import { isObservable } from "rxjs";
export function $(_a) {
    var children = _a.children;
    // store children
    var _b = __read(useState(null), 2), cn = _b[0], setCn = _b[1];
    useEffect(function () {
        // multiple children, one of em might be observable
        if (Array.isArray(children)) {
            setCn(children.map(function (c) { return React.createElement($, null, c); }));
            return;
        }
        // single observable child
        if (isObservable(children)) {
            var sub_1 = children.subscribe(function (cn) {
                setCn(cn);
            });
            return function () { return sub_1.unsubscribe(); };
        }
        // child is just a child
        setCn(children);
    }, [children]);
    // render children as array
    return Array.isArray(cn)
        ? React.createElement.apply(React, __spread([React.Fragment, null], cn)) : React.createElement(React.Fragment, null, cn);
}
